unit UnitChatRL;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls,WinSock, Buttons, ScktComp, ExtCtrls, Grids,
   Menus, Math,ShellAPI;

type
  TChatRL = class(TForm)
    PageControl: TPageControl;
    TabSheetServeur: TTabSheet;
    TabSheetClient: TTabSheet;
    StatusBarServeur: TStatusBar;
    StatusBarClient: TStatusBar;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    LabelIP: TLabel;
    Label2: TLabel;
    ComboBoxNombresClients: TComboBox;
    ClientSocket: TClientSocket;
    ServerSocket: TServerSocket;
    TimerNombresClientsActuels: TTimer;
    GroupBoxConnexion: TGroupBox;
    ListBoxNomUtilisateur: TListBox;
    Label3: TLabel;
    GroupBoxActivite: TGroupBox;
    MemoActivite: TMemo;
    GroupBoxClientListe: TGroupBox;
    ListBoxListeRL: TListBox;
    Label4: TLabel;
    GroupBoxConnexionActive: TGroupBox;
    BitBtnActualiserReseau: TBitBtn;
    StaticText1: TStaticText;
    ComboBoxListeOrdinateur: TComboBox;
    StaticText2: TStaticText;
    EditLogin: TEdit;
    BitBtnConnection: TBitBtn;
    StaticText3: TStaticText;
    StaticText4: TStaticText;
    EditIPConnexion: TEdit;
    GroupBoxChat: TGroupBox;
    MemoChat: TMemo;
    StaticText6: TStaticText;
    BitBtnDeconnexion: TBitBtn;
    BitBtnEjecter: TBitBtn;
    BitBtn1: TBitBtn;
    TimerInformationsChateur: TTimer;
    BitBtn2: TBitBtn;
    MainMenu1: TMainMenu;
    LeChat1: TMenuItem;
    Fermer1: TMenuItem;
    Options1: TMenuItem;
    Reglages1: TMenuItem;
    Apropos1: TMenuItem;
    BitBtnLancerS: TBitBtn;
    TimerTitre: TTimer;
    StaticText5: TStaticText;
    EditPortServeur: TEdit;
    StaticText7: TStaticText;
    EditPortClient: TEdit;
    Memo1: TMemo;
    Musique1: TMenuItem;
    Aide1: TMenuItem;
    Edit1: TEdit;
    Label5: TLabel;
    EditAdresseIP: TEdit;
    Label6: TLabel;
    EditIP: TEdit;
    Label7: TLabel;
    EditMessageEcrit: TEdit;
    Label8: TLabel;
    EditNomPC: TEdit;
    Label9: TLabel;
    procedure TabSheetServeurShow(Sender: TObject);
    function TrouverIP(ordinateur : string) : string;
    function NomPcActuel : string;
    function MessageInfo : string;
    procedure FormCreate(Sender: TObject);
    procedure ServerSocketAccept(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerSocketClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure TimerNombresClientsActuelsTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtnLancerSClick(Sender: TObject);
    procedure BitBtnActualiserReseauClick(Sender: TObject);
    procedure ListBoxListeRLMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ServerSocketClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocketError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure BitBtnConnectionClick(Sender: TObject);
    procedure ServerSocketClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure AnalysePremiereInformation(MessageRecu : string);
    procedure AnalyseDerniereInformation(MessageRecu : string);
    procedure AnalyseMessageDuChat(MessageRecu : string);
    procedure AffichageListeLogin;
    procedure ListBoxNomUtilisateurMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ComboBoxListeOrdinateurKeyPress(Sender: TObject;
      var Key: Char);
    procedure BitBtn1Click(Sender: TObject);
    procedure TimerInformationsChateurTimer(Sender: TObject);
    procedure ClientSocketRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure NomClientParti;
    procedure PageControlChanging(Sender: TObject;
      var AllowChange: Boolean);
    procedure BitBtnEjecterClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Fermer1Click(Sender: TObject);
    procedure Reglages1Click(Sender: TObject);
    procedure Colorier;
    procedure RendreVisiblePremierPlan;
    procedure PasLeDroitDeSeConnecter(Login : string; Ordi : string; iden : integer);
    procedure PourquoiDeconnecte(raison : string; iden : integer);
    procedure VientDeSeDeconnecterVolontairement(MessageRecu : string);
    procedure VientDeSeDeconnecterCarVire(MessageRecu : string);
    procedure TropDeMondeSurLeServeur(MessageRecu : string);
    procedure ReponseDeMessagePrive(MessageRecu : string; MessageEnvoi : string);
    procedure DireQueOnSeDeconnecte;
    procedure BitBtnDeconnexionClick(Sender: TObject);
    procedure ComboBoxNombresClientsKeyPress(Sender: TObject;
      var Key: Char);
    procedure TimerTitreTimer(Sender: TObject);
    procedure EditPortServeurKeyPress(Sender: TObject; var Key: Char);
    procedure EditPortClientKeyPress(Sender: TObject; var Key: Char);
    procedure Apropos1Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Memo1DblClick(Sender: TObject);
    procedure ListBoxNomUtilisateurDblClick(Sender: TObject);
    procedure Musique1Click(Sender: TObject);
    procedure Aide1Click(Sender: TObject);
    procedure AnalyseMessageRecuParServeur(Msg : String);
    procedure AnalyseMessageRecuParClient(Msg : String);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure EditMessageEcritKeyPress(Sender: TObject; var Key: Char);


  private
    { Dclarations prives }


  public
    { Dclarations publiques }


  protected
        IsServer: Boolean;
  end;

type
    TStructureListeConnecte = record
         LoginConnecte : string[30];
         NomOrdinateur : string[30];
         Iden : integer;
    end;


var
  ChatRL: TChatRL;
  Titre : string;
  StructureOrdinateur,StructureOrdinateur002 :array[1..52] of TStructureListeConnecte;
  NumeroArriveConnexion,NombresMaximumClients,NombreSecret : integer;
  ServeurActif,ClientConnecter : boolean;
  Couleur : TColor;
  Present: TDateTime;
  Hour, Min, Sec,MSec: Word;
  ChatHauteurDeDebut,ChatLargeurDeDebut,PageHauteurDebut,PageLargeurDebut : integer;


implementation

uses UnitPatience, ChoixCouleurPanel, APropos, Unit_MsgPerso, Unit_Musique;

{$R *.dfm}

function QuelHeureEstIl : string;
begin
   Present:= Now;
   DecodeTime(Present, Hour, Min, Sec,MSec);
   result := '['+IntToStr(Hour)+':'+IntToStr(Min)+':'+IntToStr(Sec)+']';
end;

function droite(substr: string; s: string): string;
begin
  if pos(substr,s)=0 then result:='' else
    result:=copy(s, pos(substr, s)+length(substr), length(s)-pos(substr, s)+length(substr));
end;


function gauche(substr: string; s: string): string;
{============================================================================}
{ fonction qui renvoie la sous chaine de caractre situ  gauche de la sous }
{ chaine substr                                                              }
{ ex: si substr = '\' et S= 'truc\tr\essai.exe' gauche renvoie truc           }
{============================================================================}
begin
  result:=copy(s, 1, pos(substr, s)-1);
end;


procedure TChatRL.RendreVisiblePremierPlan;
begin
   if (ChoixCouleur.RadioGroupVisible.ItemIndex = 0) then
   begin
     Application.Restore;
     Application.BringToFront;
   end;
end;


function TChatRL.TrouverIP(ordinateur : string) : string;
var
   WSAData : TWSAData;
   Name,Address : String;
   Phe : PHostEnt;
begin
    // Demarrage du gestinnaire de socket
    WSAStartup(2,WSAData);
    SetLength(Name,255);
    Phe := GetHostByName(PChar(ordinateur));
    with Phe^ do
    // formatahe du resultat en string
    Address := Format ('%d.%d.%d.%d' , [Byte(h_addr^[0]),Byte(h_addr^[1]),
                                        Byte(h_addr^[2]),Byte(h_addr^[3])]);
    // fermeture du gestinnaire de socket
    WSACleanup;
    TrouverIP := Address;
end;

function TChatRL.NomPcActuel : string;   // permet de trouver le Nom du pc actuel
var
  Buffer : array[0..255] of char;
  BufferSize : DWORD;
begin
  BufferSize := sizeOf(Buffer);
  GetComputerName(@buffer, BufferSize);
  result := buffer;
end;


procedure TChatRL.TabSheetServeurShow(Sender: TObject);
begin
        LabelIP.Caption := TrouverIP(NomPcActuel);
        GroupBox1.Caption := 'Caractristiques du Serveur : '+NomPcActuel;
        ComboBoxNombresClients.ItemIndex := 8;
end;



procedure TChatRL.FormCreate(Sender: TObject);
var
   i,x,y : integer;
   SysMenu: hMenu;
begin
  {modifions le menu de la fentre :}
  {demandons lhandel du menu afin de pouvoir nous adresser  lui}
  SysMenu := GetSystemMenu(Handle, False);
  {modifions un lment du menu}
  ModifyMenu(SysMenu, sc_Close, mf_ByCommand, sc_Close, '&Quitter le Chat de Scarabee !!!'#9'Alt+F4');
  {supprimons un lment du menu : dans le cas prsent,  dimension }
  //DeleteMenu(SysMenu, Sc_Size, mf_ByCommand);
  {modifions le menu de lapplication, en suivant le mme principe :}
  SysMenu := GetSystemMenu(application.handle,false);
  ModifyMenu(SysMenu, sc_Close, mf_ByCommand, sc_Close, '&Quitter le Chat de Scarabee !!!'#9'Alt+F4');

  //SysMenu := GetSystemMenu(Handle, False);
  {La destruction de l'article de fermeture du menu rend inactif le bouton et le raccourci clavier}
  //DeleteMenu(SysMenu, sc_Close, mf_ByCommand);
  {Destruction de l'article de sparation, devenu inutile}
  //DeleteMenu(SysMenu,5,Mf_ByPosition);

   x:=Screen.Width;
   y := Screen.height;

   ChatRL.Height := Round(679 * (x / 1024));
   ChatRL.Width  := Round(563 * (y / 768));
   ChatHauteurDeDebut := ChatRL.Height;
   ChatLargeurDeDebut := ChatRL.Width;

   PageControl.Height := Round(633 * (x / 1024));
   PageControl.Width  := Round(555 * (y / 768));
   PageHauteurDebut := PageControl.Height;
   PageLargeurDebut := PageControl.Width;

   Titre := 'Le Chat pour le Rseau Local & Internet                   (Fait par Scarabee)                   ';
   Couleur := clBtnFace;
   FormPatience := TFormPatience.Create(ChatRL);
   ChoixCouleur := TChoixCouleur.Create(ChatRL);
   
   Randomize;
   NombreSecret := Random(9999);

   For i := 2 to 50 do
   begin
       ComboBoxNombresClients.Items.Add(IntToStr(i));
   end;

end;

procedure TChatRL.ServerSocketAccept(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  IsServer := True;
end;

procedure TChatRL.ServerSocketClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
     //Showmessage('le client est connect : '+Socket.RemoteHost);
     inc(NumeroArriveConnexion);
     TimerInformationsChateur.Enabled := TRUE;
end;

procedure TChatRL.TimerNombresClientsActuelsTimer(Sender: TObject);
begin
    {Renvoie le nombre de connections active periodiquement grace au timer}
    application.ProcessMessages;
    StatusBarServeur.Panels[0].Text :='Actuellement, '+IntToStr(ServerSocket.Socket.ActiveConnections)+' personnes sont connectes  ce serveur.';
end;

procedure TChatRL.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Fermer1Click(ChatRL);
end;

procedure TChatRL.BitBtnLancerSClick(Sender: TObject);
var
  i : integer;
begin
   if  (CompareStr('Lancer le Serveur',BitBtnLancerS.Caption)=0)  then
   begin
      if (EditPortServeur.Text <> '') and ((strtoint(EditPortServeur.Text)) > 0) then
      begin
      try
        NombresMaximumClients := StrToInt(ComboBoxNombresClients.Items[ComboBoxNombresClients.ItemIndex]);
        ComboBoxNombresClients.Enabled := FALSE;
        EditPortServeur.Enabled := FALSE;
        ServerSocket.Port := strtoint(EditPortServeur.Text);
        ServerSocket.Active := True;
        BitBtnLancerS.Caption := 'Arrter le Serveur';
        ServeurActif := TRUE;
        NombresMaximumClients := StrToInt(ComboBoxNombresClients.items[ComboBoxNombresClients.itemindex]);
        //showmessage(inttostr(NombresMaximumClients));
        Edit1.SetFocus;
      except on ESocketError do
      begin
         MessageDlg('Vous ne pouvez pas lancer 2 serveurs sur un mme ordinateur.', mtInformation, [mbOK], 0);
         BitBtnLancerS.Caption := 'Lancer le Serveur';
          TimerInformationsChateur.Enabled := FALSE;
          TimerInformationsChateur.Interval := 3000;
          ListBoxNomUtilisateur.Clear;
          fillchar(StructureOrdinateur,sizeof(StructureOrdinateur),0);
          fillchar(StructureOrdinateur002,sizeof(StructureOrdinateur002),0);
          NumeroArriveConnexion :=0;
          ServerSocket.Active := FALSE;
          ServeurActif := FALSE;
          ComboBoxNombresClients.Enabled := TRUE;
          EditPortServeur.Enabled := TRUE;
      end;
      end;
      end;
   end
   else if (CompareStr(BitBtnLancerS.Caption,'Arrter le Serveur') =0) then
        begin
          for i:=0 to NumeroArriveConnexion-1 do
          begin
             ServerSocket.Socket.Connections[i].SendText(#13+'׻');  // envoie vers le client
          end;
          BitBtnLancerS.Caption := 'Lancer le Serveur';
          TimerInformationsChateur.Enabled := FALSE;
          TimerInformationsChateur.Interval := 3000;
          ListBoxNomUtilisateur.Clear;
          fillchar(StructureOrdinateur,sizeof(StructureOrdinateur),0);
          fillchar(StructureOrdinateur002,sizeof(StructureOrdinateur002),0);
          NumeroArriveConnexion :=0;
          ServerSocket.Active := FALSE;
          ServeurActif := FALSE;
          ComboBoxNombresClients.Enabled := TRUE;
          EditPortServeur.Enabled := TRUE;
        end;

end;

procedure TChatRL.BitBtnActualiserReseauClick(Sender: TObject);
begin
    ListBoxListeRL.Clear;
    BitBtnActualiserReseau.Enabled := FALSE;

    FormPatience.Show;
    FormPatience.RechercheEffective;
end;

procedure TChatRL.ListBoxListeRLMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
    i : integer;
begin
   for i := 0 to (ListBoxListeRL.Items.Count - 1) do
   begin
      if ListBoxListeRL.Selected[i] then
      begin
        EditIP.Text := TrouverIP(ListBoxListeRL.Items.Strings[i]);
      end;
   end;
end;

procedure TChatRL.ServerSocketClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
      dec(NumeroArriveConnexion);
      if NumeroArriveConnexion = 0 then
      begin
        TimerInformationsChateur.Enabled := FALSE;
        TimerInformationsChateur.Interval := 3000;
      end;
end;

{Client vient de se connecter au serveur}
procedure TChatRL.ClientSocketConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var
   MessageInitial : string;
begin
     Application.ProcessMessages;
     
     ClientConnecter := TRUE;

     
     BitBtnConnection.Enabled := FALSE;
     GroupBoxClientListe.Enabled := FALSE;
     GroupBoxConnexionActive.Enabled := FALSE;
     GroupBoxChat.Enabled := TRUE;
     BitBtnDeconnexion.Enabled := TRUE;


     StatusBarClient.Panels[0].Text := 'Connect au serveur : ' + Socket.RemoteHost;
     MessageInitial := '' + EditLogin.Text + '' + NomPcActuel + '/\' + inttostr(NombreSecret)+'';
     ClientSocket.Socket.SendText(#13+MessageInitial);
     EditMessageEcrit.SetFocus;
     Application.ProcessMessages;
end;


procedure TChatRL.ClientSocketDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
    Application.ProcessMessages;
end;

procedure TChatRL.ClientSocketError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
     // erreur de connexion avec le serveur
     Application.ProcessMessages;
     StatusBarClient.Panels[0].Text := 'Connexion perdu avec le serveur ...';
     MessageDlg('Erreur de connexion avec le serveur'+chr(13)
     +'Vrifier que le serveur est lanc.'+chr(13)
     +'L''adresse IP est elle valide ?'+chr(13)
     +'Le port de connexion doit tre celui du serveur.'+chr(13)
     +'Dsol... mais normalement a marche !!!', mtInformation, [mbOK], 0);
     ErrorCode := 0;

     Application.ProcessMessages;
     BitBtnConnection.Enabled := TRUE;
     GroupBoxClientListe.Enabled := TRUE;
     GroupBoxConnexionActive.Enabled := TRUE;
     EditPortClient.Enabled := TRUE;
     BitBtnDeconnexion.Enabled := FALSE;
     GroupBoxChat.Enabled := FALSE;
     Memo1.Clear;
     StatusBarClient.Panels[0].Text := 'Connexion perdu avec le serveur ...';

     ClientSocket.Active := FALSE;
     ClientSocket.Close;
     ClientConnecter := FALSE;
end;

procedure TChatRL.BitBtnConnectionClick(Sender: TObject);
var
   IPServeur : string;
begin
    if (ComboBoxListeOrdinateur.Items[ComboBoxListeOrdinateur.ItemIndex] = '')
        and (EditIPConnexion.Text = '' ) then
    begin
        MessageDlg('Vous devez choisir un ordinateur  connecter (Nom ou Adresse IP).', mtInformation, [mbOK], 0);
    end
    else if (EditLogin.Text = '') or (CompareText(EditLogin.Text,'Serveur')=0) then
         begin
             MessageDlg('Vous devez choisir un login pour vous connecter.', mtInformation, [mbOK], 0);
         end
         else if (ComboBoxListeOrdinateur.Items[ComboBoxListeOrdinateur.ItemIndex] <> '') and
               (EditPortClient.Text <> '') and ((strtoint(EditPortClient.Text)) > 0) then
              begin
                IPServeur := TrouverIP(ComboBoxListeOrdinateur.Items[ComboBoxListeOrdinateur.ItemIndex]);
                if Length(IPServeur) > 0 then
                begin
                  ClientSocket.Address := IPServeur;
                  ClientSocket.Port := strtoint(EditPortClient.Text);
                  ClientSocket.Active := TRUE;
                  StatusBarClient.Panels[0].Text := 'En attente de connexion avec le serveur '+ComboBoxListeOrdinateur.Items[ComboBoxListeOrdinateur.ItemIndex]+' ...';
                end;
              end
              else if (ComboBoxListeOrdinateur.Items[ComboBoxListeOrdinateur.ItemIndex] = '')
                       and (EditIPConnexion.Text <> '' ) and (EditPortClient.Text <> '') and
                       ((strtoint(EditPortClient.Text)) > 0) then
                   begin
                       IPServeur := EditIPConnexion.Text;
                       ClientSocket.Host := IPServeur;
                       ClientSocket.Port := strtoint(EditPortClient.Text);
                       ClientSocket.Active := TRUE;
                       StatusBarClient.Panels[0].Text := 'En attente de connexion avec le serveur ('+IPServeur+') ...';
                   end;
end;

procedure TChatRL.ServerSocketClientRead(Sender: TObject;Socket: TCustomWinSocket);
var
    TEMPO : string;
begin
  Application.ProcessMessages;
  TEMPO := socket.ReceiveText;

  while (pos(#13,TEMPO) <> 0) do
  begin
     AnalyseMessageRecuParServeur(gauche(#13,TEMPO));
     TEMPO := droite(#13,TEMPO);
  end;
  AnalyseMessageRecuParServeur(TEMPO);

end;


procedure TChatRL.AnalyseMessageRecuParServeur(Msg : String);
var
    MessageRecuServeur, MessagePrivePourLesClient: string;
begin
     MessageRecuServeur := Msg;
     if copy(MessageRecuServeur,1,1) = '' then
     begin
          //MessageInitial := '' + EditLogin.Text + '' + NomPcActuel + '/\' + NombreSecret+'';
          if NombresMaximumClients+1 > ServerSocket.Socket.ActiveConnections then
          begin
            MessageRecuServeur := Gauche('',MessageRecuServeur);
            AnalysePremiereInformation(copy(MessageRecuServeur,2,length(MessageRecuServeur)-1));
          end
          else
          begin
              // trop de monde sur le serveur
              MessageRecuServeur := Gauche('',MessageRecuServeur);
              TropDeMondeSurLeServeur(copy(MessageRecuServeur,2,length(MessageRecuServeur)-1));
          end;
     end;


     if Comparestr(copy(MessageRecuServeur,1,5),'@DECO') = 0 then
     begin
              MessageRecuServeur := Gauche('',MessageRecuServeur);
              MessageRecuServeur := Droite('@DECO',MessageRecuServeur);
              AnalyseDerniereInformation(MessageRecuServeur);
              ListBoxNomUtilisateur.Clear;
              AffichageListeLogin;
              NomClientParti;

              VientDeSeDeconnecterVolontairement(MessageRecuServeur);

     end;

     if Comparestr(copy(MessageRecuServeur,1,5),'@VIRE') = 0 then
     begin
              MessageRecuServeur := Gauche('',MessageRecuServeur);
              MessageRecuServeur := Droite('@VIRE',MessageRecuServeur);
              AnalyseDerniereInformation(MessageRecuServeur);
              ListBoxNomUtilisateur.Clear;
              AffichageListeLogin;
              NomClientParti;

              VientDeSeDeconnecterCarVire(MessageRecuServeur);
     end;


     if copy(MessageRecuServeur,1,4) = '' then
     begin
          AnalyseMessageDuChat(copy(MessageRecuServeur,5,length(MessageRecuServeur)-4));
     end;


     {Message Priv}
     if Comparestr(copy(MessageRecuServeur,1,8),'MsgPrive')=0 then
     begin
         MessagePrivePourLesClient := MessageRecuServeur;
 //'MsgPrive'+'#DE#'+ChatRL.EditLogin.Text+'#POUR#'+TrouverNomLoginQuiRecoitMsg+'#CORPS#'+Edit1.Text+'#FIN#'
         MessageRecuServeur := Gauche('#FIN#',MessageRecuServeur);
         MessageRecuServeur := Droite('MsgPrive#DE#',MessageRecuServeur);
         ReponseDeMessagePrive(MessageRecuServeur,MessagePrivePourLesClient);
     end;
end;


procedure TChatRL.ReponseDeMessagePrive(MessageRecu : string; MessageEnvoi : string);
var
   LoginEnvoi, LoginRecoi, MessageTexte : string;
   i : integer;
begin
//ChatRL.EditLogin.Text+'#POUR#'+TrouverNomLoginQuiRecoitMsg+'#CORPS#'+Edit1.Text
    LoginEnvoi := Gauche('#POUR#',MessageRecu);
    MessageRecu := Droite('#POUR#',MessageRecu);
    LoginRecoi := Gauche('#CORPS#',MessageRecu);
    MessageTexte := Droite('#CORPS#',MessageRecu);

    MemoActivite.Lines.Add('Message Priv de '+LoginEnvoi+' pour '+LoginRecoi+' >>  '+MessageTexte);
    for i:=0 to NumeroArriveConnexion-1 do
    begin
      ServerSocket.Socket.Connections[i].SendText(#13+MessageEnvoi);
    end;

end;


procedure TChatRL.TropDeMondeSurLeServeur(MessageRecu : string);
var
   i,iden : integer;
   Login,NomOrdi,MessageInfoDepart : string;
begin
   //EditLogin.Text + '' + NomPcActuel+'/\'+inttostr(NombreSecret)
   Application.ProcessMessages;
   Login := Gauche('',MessageRecu);
   MessageRecu := Droite('',MessageRecu);
   NomOrdi := Gauche('/\',MessageRecu);
   iden := strtoint(Droite('/\',MessageRecu));

   MessageInfoDepart := 'TuEsVir鰣'+Login+''+NomOrdi+'/\'+inttostr(iden)+'003';

   for i:=0 to NumeroArriveConnexion-1 do
   begin
      ServerSocket.Socket.Connections[i].SendText(#13+MessageInfoDepart);
   end;
end;


procedure TChatRL.VientDeSeDeconnecterVolontairement(MessageRecu : string);
var
   Login,NomOrdi : string;
   m : integer;
begin
   //EditLogin.Text + '' + NomPcActuel+'/\'+inttostr(NombreSecret)
   Application.ProcessMessages;
   Login := Gauche('',MessageRecu);
   MessageRecu := Droite('',MessageRecu);
   NomOrdi := Gauche('/\',MessageRecu);

   MemoActivite.Lines.Add('Serveur'+' >>  '+Login+' ('+NomOrdi+')'+' vient de se dconnecter !!!   '+QuelHeureEstIl);
   for m:=0 to NumeroArriveConnexion-1 do
   begin
       ServerSocket.Socket.Connections[m].SendText(#13+'ٿ'+''+'Serveur'+' >>  '+Login+' ('+NomOrdi+')'+' vient de se dconnecter...'+'#]');
   end;

end;

procedure TChatRL.VientDeSeDeconnecterCarVire(MessageRecu : string);
var
   m : integer;
   Login,NomOrdi : string;
begin
   //EditLogin.Text + '' + NomPcActuel+'/\'+inttostr(NombreSecret)
   Application.ProcessMessages;
   Login := Gauche('',MessageRecu);
   MessageRecu := Droite('',MessageRecu);
   NomOrdi := Gauche('/\',MessageRecu);

   MemoActivite.Lines.Add('Serveur'+' >>  '+Login+' ('+NomOrdi+')'+' a t vir par le Serveur !!!   '+QuelHeureEstIl);
   for m:=0 to NumeroArriveConnexion-1 do
   begin
       ServerSocket.Socket.Connections[m].SendText(#13+'ٿ'+''+'Serveur'+' >>  '+Login+' ('+NomOrdi+')'+' a t vir par le Serveur.'+'#]');
   end;
end;

procedure TChatRL.AnalysePremiereInformation(MessageRecu : string);
var
    i,j,k,NombreIdentifiant : integer;
    login,NomOrdi,MessageInfoArrive : string;
    Remplir,LoginExisteDejaDesole : boolean;
begin
     //EditLogin.Text + '' + NomPcActuel + '/\' + NombreSecret
     Application.ProcessMessages;

     Login := Gauche('',MessageRecu);
     NomOrdi := Droite('',MessageRecu);
     NomOrdi := Gauche('/\',NomOrdi);
     NombreIdentifiant := StrToInt(Droite('/\',MessageRecu));
             
     Remplir := TRUE;
     LoginExisteDejaDesole := FALSE;

             for k := 0 to length(StructureOrdinateur)-1 do
             begin
                 if CompareStr(Login,StructureOrdinateur[k].LoginConnecte)=0 then
                 begin
                     LoginExisteDejaDesole := TRUE;
                 end;
             end;

             for j := 1 to NumeroArriveConnexion + 3 do
             begin
                if (StructureOrdinateur[j].LoginConnecte = '') and
                   (StructureOrdinateur[j].NomOrdinateur = '') and
                   (Remplir = TRUE) and (LoginExisteDejaDesole = FALSE) then
                begin
                   StructureOrdinateur[j].LoginConnecte := login;
                   StructureOrdinateur[j].NomOrdinateur :=  NomOrdi;
                   StructureOrdinateur[j].Iden := NombreIdentifiant;
                   Remplir := FALSE;
                end;
             end;

             if not Remplir then
             begin
               ListBoxNomUtilisateur.Clear;
               AffichageListeLogin;

               MessageInfoArrive := 'ٿ'+''+'Serveur'+' >>  '+login+' ('+NomOrdi+')'+' vient de se connecter.'+'#]';
               MemoActivite.Lines.Add('Serveur'+' >>  '+login+' ('+NomOrdi+')'+' vient de se connecter.   '+QuelHeureEstIl);
               for i:=0 to NumeroArriveConnexion-1 do
               begin
                  ServerSocket.Socket.Connections[i].SendText(#13+MessageInfoArrive);
               end;
             end;

             if LoginExisteDejaDesole then
                    PasLeDroitDeSeConnecter(login,NomOrdi,NombreIdentifiant);
end;

Procedure TChatRL.PasLeDroitDeSeConnecter(Login : string; Ordi : string; iden : integer);
var
   MessageInfoDepart : string;
   i : integer;
begin
   MessageInfoDepart := 'TuEsVir鰣'+Login+''+Ordi+'/\'+inttostr(iden)+'001';

   for i:=0 to NumeroArriveConnexion-1 do
   begin
      ServerSocket.Socket.Connections[i].SendText(#13+MessageInfoDepart);
   end;
end;


procedure TChatRL.AnalyseDerniereInformation(MessageRecu : string);
var
    j,k,l,UnCranDeMoins,Identifiant : integer;
    login,NomOrdi : string;
begin
     Application.ProcessMessages;
     //EditLogin.Text + '' + NomPcActuel+'/\'+inttostr(NombreSecret)

     Login := Gauche('',MessageRecu);
     MessageRecu := Droite('',MessageRecu);
     NomOrdi := Gauche('/\',MessageRecu);
     Identifiant := strtoint(Droite('/\',MessageRecu));

         for j:=1 to 52 do
         begin
             if (CompareStr(StructureOrdinateur[j].LoginConnecte, Login)=0)
                and (CompareStr(StructureOrdinateur[j].NomOrdinateur, NomOrdi)=0)
                and (Identifiant = StructureOrdinateur[j].Iden) then
             begin
                StructureOrdinateur[j].LoginConnecte := '';
                StructureOrdinateur[j].NomOrdinateur := '';
                StructureOrdinateur[j].Iden := 0;

                fillchar(StructureOrdinateur002,sizeof(StructureOrdinateur002),0); // mettre la structure  zero
                UnCranDeMoins :=0;

                for k :=1 to 52 do
                begin
                     if (StructureOrdinateur[k].LoginConnecte = '')
                     and (StructureOrdinateur[k].NomOrdinateur ='')
                     and (StructureOrdinateur[k].Iden = 0)  then
                     begin
                         inc(UnCranDeMoins);
                     end
                     else
                     begin
                          StructureOrdinateur002[k-UnCranDeMoins].LoginConnecte := StructureOrdinateur[k].LoginConnecte;
                          StructureOrdinateur002[k-UnCranDeMoins].NomOrdinateur := StructureOrdinateur[k].NomOrdinateur;
                          StructureOrdinateur002[k-UnCranDeMoins].Iden := StructureOrdinateur[k].Iden;
                     end;
                end;

                fillchar(StructureOrdinateur,sizeof(StructureOrdinateur),0);
                for l :=1 to 52 do
                begin
                    if (StructureOrdinateur002[l].LoginConnecte <> '')
                       and (StructureOrdinateur002[l].NomOrdinateur <>'')
                       and (StructureOrdinateur002[l].Iden <> 0) then
                    begin
                         StructureOrdinateur[l].LoginConnecte := StructureOrdinateur002[l].LoginConnecte;
                         StructureOrdinateur[l].NomOrdinateur := StructureOrdinateur002[l].NomOrdinateur;
                         StructureOrdinateur[l].Iden := StructureOrdinateur002[l].Iden;
                    end;
                end;
             end;
         end;
end;


procedure TChatRL.AffichageListeLogin;
var
   i : integer;
begin
       Application.ProcessMessages;
       for i:=1 to NumeroArriveConnexion + 3 do
       begin
           if StructureOrdinateur[i].LoginConnecte <>'' then
           begin
                ListBoxNomUtilisateur.Items.Add(StructureOrdinateur[i].LoginConnecte);
           end;
       end;
end;

procedure TChatRL.ListBoxNomUtilisateurMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   i,j : integer;
begin
    Application.ProcessMessages;
    if NumeroArriveConnexion <> 0 then
    begin
      for i:=1 to NumeroArriveConnexion + 3 do
      begin
        for j := 0 to (ListBoxNomUtilisateur.Items.Count - 1) do
        begin
          if ListBoxNomUtilisateur.Selected[j] then
          begin
           if CompareStr(ListBoxNomUtilisateur.Items[j],StructureOrdinateur[i].LoginConnecte)=0 then
           begin
              EditNomPC.Text := StructureOrdinateur[i].NomOrdinateur;
              if FormPatience.ExistOrdiReseau(StructureOrdinateur[i].NomOrdinateur) then
                  EditAdresseIP.Text := TrouverIP(StructureOrdinateur[i].NomOrdinateur)
              else EditAdresseIP.Text := 'Hors rseau';
           end;
          end;
         end;
      end;
    end;
end;

procedure TChatRL.ComboBoxListeOrdinateurKeyPress(Sender: TObject;
  var Key: Char);
begin
    {Permet d'empecher d'ecrire dans le ComboBox sauf pour 1 lettre }
     if Key <> #223 then
            Key := #0 // valeur nul et on ne peut pas ecrire dans le comboBox
     else Key := #0;
end;



procedure TChatRL.BitBtn1Click(Sender: TObject);
begin
    MemoChat.Clear;
end;

procedure TChatRL.TimerInformationsChateurTimer(Sender: TObject);
var
   i : integer;
begin
     {permet d'envoyer le message  tous le pc client connects au serveur}
     for i:=0 to NumeroArriveConnexion-1 do
     begin
        ServerSocket.Socket.Connections[i].SendText(#13+MessageInfo);  // envoie vers le client
     end;
end;

function TChatRL.MessageInfo : string;
var
    i : integer;
    MessageInfoListeChateur,MessageInfoListeChateur1 : string;
begin
     Application.ProcessMessages;
     MessageInfoListeChateur1 := '';
     MessageInfoListeChateur := '';
     MessageInfoListeChateur := '@*@';
     for i:=1 to NumeroArriveConnexion + 3 do
     begin
        if StructureOrdinateur[i].LoginConnecte <> '' then
        begin
            MessageInfoListeChateur1 := MessageInfoListeChateur1 + '' + StructureOrdinateur[i].LoginConnecte;
        end;
     end;

     if MessageInfoListeChateur1 <> '' then
     begin
       MessageInfoListeChateur := MessageInfoListeChateur + MessageInfoListeChateur1 + '@*!@';
       result:= MessageInfoListeChateur;
     end
     else
     begin
         result:= '??';
     end;

end;


procedure TChatRL.ClientSocketRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  TEMPO : String;
begin
  Application.ProcessMessages;
  TEMPO := socket.ReceiveText;

  while (pos(#13,TEMPO) <> 0) do
  begin
     AnalyseMessageRecuParClient(gauche(#13,TEMPO));
     TEMPO := droite(#13,TEMPO);
  end;
  AnalyseMessageRecuParClient(TEMPO);
end;


procedure TChatRL.AnalyseMessageRecuParClient(Msg : String);
var
    MessageRecuClient,LoginEnvoi,LoginRecoi,MessageTexte  : string;
    i,j,k,l,Identifiant : integer;
    TableauLocal : array [1..52] of integer;
    Personnage,LoginDemander,OrdiDemander : string;
    Ajouter : Boolean;
begin
     MessageRecuClient := Msg;
     if (CompareStr(copy(MessageRecuClient,1,5),'@*@') =0) and (CompareStr(copy(MessageRecuClient,length(MessageRecuClient)-5,6),'@*!@')=0) then
     begin
          k:=0;
          fillchar(TableauLocal,sizeof(TableauLocal),0);

          for j:=1 to length(MessageRecuClient)-5 do
          begin
               if MessageRecuClient[j] = '' then
               begin
                 inc(k);
                 TableauLocal[k] := j;
               end;
          end;


           if k <> 0 then
              begin
                 for l:= 1 to k-1 do
                 begin
                    Personnage := copy(MessageRecuClient,TableauLocal[l]+1,(TableauLocal[l+1])-TableauLocal[l]-1);
                    if (CompareStr(Personnage,'')<> 0) and (comparestr(Personnage,'@*!@@*@') <> 0) then
                    begin
                         Ajouter := TRUE;
                         if Memo1.Lines.Count = 0 then
                         begin
                             Memo1.Lines.Add(Personnage);
                         end
                         else
                         begin
                             For i:=0 to Memo1.Lines.Count-1 do
                             begin
                                  if comparestr(Memo1.Lines[i],Personnage) = 0 then
                                  begin
                                      Ajouter := FALSE;
                                  end;
                             end;
                             if Ajouter then
                             begin
                                  Memo1.Lines.Add(Personnage);
                             end;
                         end;
                    end;
                 end;
              end;
     end;

     if CompareStr(copy(MessageRecuClient,1,3),'') =0 then
     begin
         Memo1.Clear;
         if length(MessageRecuClient) > 5 then
         begin
             MessageRecuClient := Droite('',MessageRecuClient);
         end;
     end;

     //'TuEsVir鰣'+LoginVirer+''+OrdiVirer+'/\'+inttostr(Identifiant)+'002';
     if CompareStr(copy(MessageRecuClient,1,11),'TuEsVir鰣') =0 then
     begin
      //showmessage(MessageRecuClient);
         MessageRecuClient := Droite('TuEsVir鰣',MessageRecuClient);
         LoginDemander :=  Gauche('',MessageRecuClient);
         MessageRecuClient := Droite('',MessageRecuClient);
         OrdiDemander := Gauche('/\',MessageRecuClient);
         MessageRecuClient := Droite('/\',MessageRecuClient);
         Identifiant := StrToInt(copy(MessageRecuClient,1,length(MessageRecuClient)-3));

                  if (comparestr(EditLogin.Text,LoginDemander)=0) and
                     (comparestr(NomPcActuel,OrdiDemander)=0) and
                     (Identifiant = NombreSecret) then
                  begin
                    if CompareStr(copy(MessageRecuClient,length(MessageRecuClient)-2,3),'001') =0 then
                    begin
                        {Expulser car 2 meme login}
                         PourquoiDeconnecte('001',Identifiant);
                    end;
                    if CompareStr(copy(MessageRecuClient,length(MessageRecuClient)-2,3),'002') =0 then
                    begin
                        {Ejecter sans raison par le serveur}
                         PourquoiDeconnecte('002',Identifiant);
                    end;
                    if CompareStr(copy(MessageRecuClient,length(MessageRecuClient)-2,3),'003') =0 then
                    begin
                        {Trop de monde chez le serveur}
                        PourquoiDeconnecte('003',Identifiant);
                    end;
                  end;
     end;



     if CompareStr(copy(MessageRecuClient,1,5),'ٿ') =0 then
     begin
         if CompareStr(copy(MessageRecuClient,length(MessageRecuClient)-4,5),'#]') =0 then
         begin
             MessageRecuClient := Gauche('#]',MessageRecuClient);
             MessageRecuClient := Droite('ٿ',MessageRecuClient);
             
             if ChoixCouleur.RadioGroupSons.ItemIndex = 1 then
             begin
                 MessageBeep(MB_OK);
             end;
             RendreVisiblePremierPlan;

             if CompareStr(copy(MessageRecuClient,1,4),'') =0 then
             begin
                  MessageRecuClient := Droite('',MessageRecuClient);
                  MemoChat.Lines.Add(MessageRecuClient+'   '+QuelHeureEstIl);
             end
             else
             begin
                MemoChat.Lines.Add(MessageRecuClient);
             end;
         end;
     end;


//'MsgPrive'+'#DE#'+ChatRL.EditLogin.Text+'#POUR#'+TrouverNomLoginQuiRecoitMsg+'#CORPS#'+Edit1.Text+'#FIN#'
     if CompareStr(copy(MessageRecuClient,1,8),'MsgPrive') =0 then
     begin
         MessageRecuClient := Gauche('#FIN#',MessageRecuClient);
         MessageRecuClient := Droite('MsgPrive#DE#',MessageRecuClient);
         LoginEnvoi := Gauche('#POUR#',MessageRecuClient);
         MessageRecuClient := Droite('#POUR#',MessageRecuClient);
         LoginRecoi := Gauche('#CORPS#',MessageRecuClient);

         if (Comparestr(LoginEnvoi,EditLogin.Text)=0) or (Comparestr(LoginRecoi,EditLogin.Text)=0) then
         begin
              MessageTexte := Droite('#CORPS#',MessageRecuClient);
              if ChoixCouleur.RadioGroupSons.ItemIndex = 1 then
              begin
                 MessageBeep(MB_OK);
              end;
              RendreVisiblePremierPlan;
              MemoChat.Lines.Add('Message Priv de '+LoginEnvoi+' pour '+LoginRecoi+' >>  '+MessageTexte);
         end;


     end;



     if CompareStr(copy(MessageRecuClient,1,5),'׻') =0 then
     begin
        MemoChat.Lines.Add('Le Serveur vient de se dconnecter...  '+QuelHeureEstIl);
        Application.ProcessMessages;
        BitBtnConnection.Enabled := TRUE;
        GroupBoxClientListe.Enabled := TRUE;
        GroupBoxConnexionActive.Enabled := TRUE;
        BitBtnDeconnexion.Enabled := FALSE;
        GroupBoxChat.Enabled := FALSE;
        Memo1.Clear;
        StatusBarClient.Panels[0].Text := 'Connexion perdu avec le serveur ...';
        ClientSocket.Active := FALSE;
        ClientSocket.Close;
        ClientConnecter := FALSE;
     end;

end;

procedure TChatRL.PourquoiDeconnecte(raison : string; iden : integer);
var
  MessageFinal : string;
begin
     case StrToInt(raison) of
     001 : begin
              MessageDlg('Votre login est dj utilis.', mtInformation, [mbOK], 0);
           end;
     002 : begin
              MessageFinal := '@VIRE' + EditLogin.Text + '' + NomPcActuel+'/\'+inttostr(iden)+'';
              ClientSocket.Socket.SendText(#13+MessageFinal);

              Application.ProcessMessages;
              BitBtnConnection.Enabled := TRUE;
              GroupBoxClientListe.Enabled := TRUE;
              GroupBoxConnexionActive.Enabled := TRUE;
              EditPortClient.Enabled := TRUE;
              BitBtnDeconnexion.Enabled := FALSE;
              GroupBoxChat.Enabled := FALSE;
              Memo1.Clear;
              MessageDlg('Vous venez d''tre expuls par le Serveur...', mtInformation, [mbOK], 0);
              StatusBarClient.Panels[0].Text := 'Connexion perdu avec le serveur ...';

              ClientSocket.Active := FALSE;
              ClientSocket.Close;
              ClientConnecter := FALSE;
           end;
     003 : begin
              MessageDlg('Le serveur est plein. Veuillez ressayer ultrieurement.', mtInformation, [mbOK], 0);
           end;
     end;

     Application.ProcessMessages;
     BitBtnConnection.Enabled := TRUE;
     GroupBoxClientListe.Enabled := TRUE;
     GroupBoxConnexionActive.Enabled := TRUE;
     BitBtnDeconnexion.Enabled := FALSE;
     GroupBoxChat.Enabled := FALSE;
     Memo1.Clear;
     StatusBarClient.Panels[0].Text := 'Connexion perdu avec le serveur ...';

     ClientSocket.Active := FALSE;
     ClientSocket.Close;
     ClientConnecter := FALSE;
end;


procedure TChatRL.NomClientParti;
var
   i : integer;
   MessageInfoDepart : string;
begin
     MessageInfoDepart := '';
     for i:=0 to NumeroArriveConnexion-1 do
     begin
        ServerSocket.Socket.Connections[i].SendText(#13+MessageInfoDepart);  // envoie vers le client
     end;
end;

{Grer le changement d'onglet}
procedure TChatRL.PageControlChanging(Sender: TObject;
  var AllowChange: Boolean);
begin
  if ((Sender as TPageControl).ActivePage = TabSheetServeur) and (ServeurActif = TRUE) then
     AllowChange := FALSE
  else if ((Sender as TPageControl).ActivePage = TabSheetClient) and (ClientConnecter = TRUE) then
         AllowChange := FALSE
        else
         AllowChange := TRUE;
end;

{Virer qqun en utilisant le serveur}
procedure TChatRL.BitBtnEjecterClick(Sender: TObject);
var
   i,k,m,Identifiant : integer;
   MessageInfoDepart,OrdiVirer,LoginVirer : string;
   Envoi : boolean;
   
begin
    Envoi := FALSE;
    if (ServeurActif = TRUE) then
     begin
       Identifiant := 0;
       for i := 0 to (ListBoxNomUtilisateur.Items.Count - 1) do
       begin
          if ListBoxNomUtilisateur.Selected[i] then
          begin
              if NumeroArriveConnexion <> 0 then
              begin
               for k:=1 to NumeroArriveConnexion + 3 do
                begin
                  if CompareStr(ListBoxNomUtilisateur.Items[i],StructureOrdinateur[k].LoginConnecte)=0 then
                  begin
                     OrdiVirer := StructureOrdinateur[k].NomOrdinateur;
                     LoginVirer :=ListBoxNomUtilisateur.Items[i];
                     Identifiant := StructureOrdinateur[k].Iden;
                     Envoi := TRUE;
                  end;
                end;
              end;
          end;
       end;
       if Envoi then
       begin
             MessageInfoDepart := 'TuEsVir鰣'+LoginVirer+''+OrdiVirer+'/\'+inttostr(Identifiant)+'002';
             
             for m:=0 to NumeroArriveConnexion-1 do
             begin
                ServerSocket.Socket.Connections[m].SendText(#13+MessageInfoDepart);
             end;
       end;
     end;

end;


procedure TChatRL.AnalyseMessageDuChat(MessageRecu : string);
var
  i,j,k,l : integer;
  Login, Msg,EnvoiTexte : string;
begin
     Application.ProcessMessages;
     k := 0;
     if (copy(MessageRecu,length(MessageRecu)-3,4) = '@?') then
     begin
       for i:=1 to length(MessageRecu) do
       begin
           if (copy(MessageRecu,i,4) = '') then
           begin
               Login := (copy(MessageRecu,1,i-1));
               k := i;
           end;
       end;

       for j:= 1 to length(MessageRecu) do
       begin
           if (copy(MessageRecu,k+j,4) = '@?') then
           begin
              Msg := (copy(MessageRecu,k+4,j-4));
           end;
       end;

       if (Msg <>'') and (Login<>'') then
       begin
           EnvoiTexte := Login + ' >>  ' +Msg;
           if ChoixCouleur.RadioGroupSons.ItemIndex = 1 then
             begin
                 MessageBeep(MB_OK);
             end;
           RendreVisiblePremierPlan;

           MemoActivite.Lines.Add(EnvoiTexte);
           for l:=0 to NumeroArriveConnexion-1 do
           begin
             ServerSocket.Socket.Connections[l].SendText(#13+'ٿ'+EnvoiTexte+'#]');  // envoie vers le client
           end;
       end;
     end;
end;



procedure TChatRL.BitBtn2Click(Sender: TObject);
begin
    MemoActivite.Clear;
end;

procedure TChatRL.Fermer1Click(Sender: TObject);
var
   i : integer;
begin
  ClipCursor(nil); // Annule la limitation du dplacement de la souris.
  if (not ClientConnecter) and (not ServeurActif) then
       Application.Terminate;

  if ServeurActif = TRUE then
  begin
    TimerNombresClientsActuels.Enabled := FALSE;
    TimerNombresClientsActuels.Interval := 100;
    for i:=0 to NumeroArriveConnexion-1 do
    begin
        ServerSocket.Socket.Connections[i].SendText(#13+'׻');  // envoie vers le client
    end;
    ServerSocket.Active := FALSE;
    Application.Terminate;
  end;

  if ClientConnecter = TRUE then
  begin
    DireQueOnSeDeconnecte;
    ClientSocket.Active := FALSE;
    sleep(1000); // pour que la deconnexion se face proprement avant la fermeture de l'application.
    Application.Terminate;
  end;

end;


procedure TChatRL.Reglages1Click(Sender: TObject);
begin
    ChoixCouleur.Show;
end;

procedure TChatRL.Colorier;
begin
    ChatRL.StatusBarServeur.Color := Couleur;
    ChatRL.StatusBarClient.Color := Couleur;
    ChatRL.GroupBox1.Color := Couleur;
    ChatRL.GroupBoxConnexion.Color := Couleur;
    ChatRL.GroupBoxActivite.Color := Couleur;
    ChatRL.GroupBoxClientListe.Color := Couleur;
    ChatRL.GroupBoxConnexionActive.Color:= Couleur;
    ChatRL.GroupBoxChat.Color := Couleur;
end;


procedure TChatRL.DireQueOnSeDeconnecte;
var
    MessageFinal : string;
begin
     Application.ProcessMessages;
     BitBtnConnection.Enabled := TRUE;
     GroupBoxClientListe.Enabled := TRUE;
     GroupBoxConnexionActive.Enabled := TRUE;
     EditPortClient.Enabled := TRUE;
     BitBtnDeconnexion.Enabled := FALSE;
     GroupBoxChat.Enabled := FALSE;
     Memo1.Clear;
     StatusBarClient.Panels[0].Text := 'Connexion perdu avec le serveur ...';

     if ClientConnecter then
     begin
     MessageFinal := '@DECO' + EditLogin.Text + '' + NomPcActuel+'/\'+inttostr(NombreSecret)+'';
     ClientSocket.Socket.SendText(#13+MessageFinal);
     //showmessage(MessageFinal);
     end;

     ClientSocket.Active := FALSE;
     ClientSocket.Close;
     ClientConnecter := FALSE;

end;

procedure TChatRL.BitBtnDeconnexionClick(Sender: TObject);
begin
       DireQueOnSeDeconnecte;
end;

procedure TChatRL.ComboBoxNombresClientsKeyPress(Sender: TObject;
  var Key: Char);
begin
    {Permet d'empecher d'ecrire dans le ComboBox sauf pour 1 lettre }
     if Key <> #223 then
            Key := #0 // valeur nul et on ne peut pas ecrire dans le comboBox
     else Key := #0;
end;


procedure TChatRL.TimerTitreTimer(Sender: TObject);
var i:integer;
begin

  application.title:=Titre;
  ChatRL.Caption:=Titre;
  for i:=1 to (length(Titre)-1) do
     Titre[i]:=application.title[i+1];
  Titre[length(Titre)]:=application.title[1];

end;

procedure TChatRL.EditPortServeurKeyPress(Sender: TObject; var Key: Char);
begin
   if key <> #8 then
   begin
     if (key < #48) or (key > #57) then
         key := #0;  
   end;

end;

procedure TChatRL.EditPortClientKeyPress(Sender: TObject; var Key: Char);
begin
   if key <> #8 then
   begin
     if (key < #48) or (key > #57) then
         key := #0;  
   end;
end;

procedure TChatRL.Apropos1Click(Sender: TObject);
begin
   if assigned(Commentaire) then
      Commentaire.show
   else
   begin
     Commentaire := TCommentaire.Create(ChatRL);
     Commentaire.Show;
   end;
end;

procedure TChatRL.FormResize(Sender: TObject);
begin

    if (ChatRl.Width >= ChatLargeurDeDebut) and (ChatRl.Height >= ChatHauteurDeDebut)  then
    begin
         ChatRl.AutoScroll := FALSE;
         PageControl.Width := ChatRl.Width - (ChatLargeurDeDebut-PageLargeurDebut);
         PageControl.Height := ChatRl.Height -(ChatHauteurDeDebut-PageHauteurDebut);
    end;

    if (ChatRl.Width < ChatLargeurDeDebut) or (ChatRl.Height < ChatHauteurDeDebut)  then
    begin
        ChatRl.AutoScroll := TRUE;
    end;

    if (ChatRl.Width >= ChatLargeurDeDebut) then
    begin
         ChatRl.AutoScroll := FALSE;
         if (ChatRl.Height < ChatHauteurDeDebut)  then
         begin
           ChatRl.AutoScroll := TRUE;
           PageControl.Width := ChatRl.Width - (ChatLargeurDeDebut-PageLargeurDebut);
         end;
    end;

    if (ChatRl.Height >= ChatHauteurDeDebut)  then
    begin
         ChatRl.AutoScroll := FALSE;
         if (ChatRl.Width < ChatLargeurDeDebut) then
         begin
            ChatRl.AutoScroll := TRUE;
            PageControl.Height := ChatRl.Height -(ChatHauteurDeDebut-PageHauteurDebut);
         end;
    end;

end;

{envoyer un message priv  un autre utilisateur}
procedure TChatRL.Memo1DblClick(Sender: TObject);
var
   Login : string;
begin
   {si un login est selectionn}
   if Memo1.SelText <> '' then
   begin
     Login := Memo1.SelText;
     if CompareStr(Login,EditLogin.Text)<> 0 then
     begin
       {fenetre existe dj}
       if assigned(MsgPerso) then
       begin
           MsgPerso.Caption := 'Vous souhaitez envoyer un message priv  '+Login+' :';
           MsgPerso.Edit1.clear;
           MsgPerso.show;
       end
       else
       begin
         MsgPerso := TMsgPerso.Create(ChatRL);
         MsgPerso.Caption := 'Vous souhaitez envoyer un message priv  '+Login+' :';
         MsgPerso.Show;
       end;
     end
     else
     begin
        MessageDlg('Personne ne peut s''envoyer un message personnel !', mtInformation, [mbOK], 0);
     end;
   end;
end;

procedure TChatRL.ListBoxNomUtilisateurDblClick(Sender: TObject);
var
   Login : string;
   j : integer;
begin
   {si un login est selectionn}
   for j := 0 to (ListBoxNomUtilisateur.Items.Count - 1) do
   begin
   if ListBoxNomUtilisateur.Selected[j] then
   begin
     Login := ListBoxNomUtilisateur.Items[j];
     if CompareStr(Login,EditLogin.Text)<> 0 then
     begin
       {fenetre existe dj}
       if assigned(MsgPerso) then
       begin
           MsgPerso.Caption := 'Vous souhaitez envoyer un message priv  '+Login+' :';
           MsgPerso.Edit1.clear;
           MsgPerso.show;
       end
       else
       begin
         MsgPerso := TMsgPerso.Create(ChatRL);
         MsgPerso.Caption := 'Vous souhaitez envoyer un message priv  '+Login+' :';
         MsgPerso.Show;
       end;
     end
     else
     begin
        MessageDlg('Personne ne peut s''envoyer un message personnel !', mtInformation, [mbOK], 0);
     end;
   end;
   end;
end;

{Gestion de la musique}
procedure TChatRL.Musique1Click(Sender: TObject);
begin
 if assigned(FormMusique) then
      FormMusique.Show
 else
 begin
    FormMusique := TFormMusique.Create(ChatRL);
    FormMusique.Show;
 end;
end;

procedure TChatRL.Aide1Click(Sender: TObject);
begin
  ShellExecute(handle, nil,PChar('Aide.txt'), nil, nil, SW_SHOWNORMAL);
end;

procedure TChatRL.Edit1KeyPress(Sender: TObject; var Key: Char);
var
  i : integer;
  MessageAEnvoyer : string;
begin
        if (Key = #13) and (Edit1.Text <> '')
            and (ServeurActif = TRUE) then
        begin
           key := #0;
           MessageAEnvoyer := Edit1.Text;
           for i:=0 to NumeroArriveConnexion-1 do
           begin
             ServerSocket.Socket.Connections[i].SendText(#13+'ٿ'+'Serveur'+' >>  '+MessageAEnvoyer+'#]');  // envoie vers le client
           end;
           MemoActivite.Lines.Add('Serveur'+' >>  '+MessageAEnvoyer);
           Edit1.Clear;
        end;
        if (Key = #13) then
               key := #0;
end;

procedure TChatRL.EditMessageEcritKeyPress(Sender: TObject; var Key: Char);
var
   i : integer;
   DroitEcrire : boolean;
   MessageAEnvoyer : string;
begin
        if (Key = #13) and (EditMessageEcrit.Text <> '')
            and (ClientConnecter = TRUE) then
        begin
           key := #0;
           DroitEcrire := FALSE;
           for i := 0 to (Memo1.Lines.Count - 1) do
           begin
             if CompareStr(EditLogin.Text,Memo1.Lines[i]) =0 then
             begin
                DroitEcrire := TRUE;
             end;
           end;
           if DroitEcrire then
           begin
              MessageAEnvoyer := ''+EditLogin.Text+''+EditMessageEcrit.Text +'@?';
              ClientSocket.Socket.SendText(#13+MessageAEnvoyer);
              EditMessageEcrit.Clear;
           end;
        end;
        if (Key = #13) then
               key := #0;

end;

initialization
        NumeroArriveConnexion :=0;

end.


