{Cette unit a t rajout apres le chat et ne sert  rien proprement dit.... sauf  ecouter de la musique en discutant}
{ca me permet de mettre 2 de mes programmes en 1 ...  comme la lessive}

unit Unit_Musique;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, MPlayer, ComCtrls;

type
  TFormMusique = class(TForm)
    OpenDialogMusique: TOpenDialog;
    ButtonRechercheMusique: TButton;
    ImagePrecedent: TImage;
    ImageSuivant: TImage;
    ImageLecture: TImage;
    ImageArret: TImage;
    ImagePause: TImage;
    MediaPlayerMusique: TMediaPlayer;
    ProgressBarMusique: TProgressBar;
    LabelTempsMusique: TLabel;
    TimerMusique: TTimer;
    TimerDefilementMusique: TTimer;
    LabelDefilement: TLabel;
    procedure ButtonRechercheMusiqueClick(Sender: TObject);
    procedure ProgressBarMusiqueMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure TimerMusiqueTimer(Sender: TObject);
    procedure ImageLectureClick(Sender: TObject);
    procedure TimerDefilementMusiqueTimer(Sender: TObject);
    procedure LectureDeLaMusique(CheminMusique : string);
    procedure RemplirTableauNomMP3Defilement(Nom : string; temps : Longword);
    procedure ImageSuivantClick(Sender: TObject);
    procedure ImageArretClick(Sender: TObject);
    procedure ImagePrecedentClick(Sender: TObject);
    procedure ImagePauseClick(Sender: TObject);

  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  FormMusique: TFormMusique;
  TableauAdresseMusique : Array of String;
  NomDuMp3Defilement : Array of String;  // Tableau qui permet le dfilement du texte dans le Label
  UnDePlus,IndiceMusique : integer;
  EtreEnPause : boolean; // Savoir si on est en cours de lecture d'un mp3 ou pas

implementation

{$R *.dfm}

function droite(substr: string; s: string): string;
begin
  if pos(substr,s)=0 then result:='' else
    result:=copy(s, pos(substr, s)+length(substr), length(s)-pos(substr, s)+length(substr));
end;

function droiteDroite(substr: string; s: string): string;
{============================================================================}
{ fonction qui renvoie la sous chaine de caractre situ  droite de la sous }
{ chaine substr situe la plus  droite                                      }
{ ex: si substr = '\' et S= 'truc\tr\essai.exe droiteDroite renvoie essai.exe}
{============================================================================}
begin
  Repeat
    S:=droite(substr,s);
  until pos(substr,s)=0;
  result:=S;
end;

{Renvoie l'indice actuel de la chanson}
function QuelEstIndiceActuel : Integer;
begin
  IndiceMusique := IndiceMusique +1;
  if IndiceMusique > length(TableauAdresseMusique) -1 then
    result := 0
  else
    result := IndiceMusique;
end;


{Remplissage du tableau avec toutes les adresses des musiques}
procedure TFormMusique.ButtonRechercheMusiqueClick(Sender: TObject);
var
  i : LongWord;
begin
  OpenDialogMusique.Options := [ofAllowMultiSelect, ofFileMustExist];
  if OpenDialogMusique.Execute then
  begin
    with OpenDialogMusique.Files do
    begin
      fillchar(TableauAdresseMusique,sizeof(TableauAdresseMusique),0);   // vider tout le tableau
      for i := 0 to Count - 1 do
      begin
        if OpenDialogMusique.Files[i] <> '' then
        begin
          setlength(TableauAdresseMusique,length(TableauAdresseMusique)+1);
          TableauAdresseMusique[i] := OpenDialogMusique.Files[i];
        end;
      end;
    end;
      IndiceMusique := 0;
      LectureDeLaMusique(TableauAdresseMusique[IndiceMusique]); // Premiere musique
  end;
end;




{Clique sur la barre de progression}
procedure TFormMusique.ProgressBarMusiqueMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  i : extended;
  SecondeTotal : Integer;
  Minute,Seconde : byte;

begin
    if TimerMusique.Enabled = TRUE then
    begin
      {position de la barre de progression}
      i := (X / (ProgressBarMusique.Width-3)) * MediaPlayerMusique.TrackLength[1];
      TimerMusique.Enabled := FALSE;
      MediaPlayerMusique.StartPos := Round(i); // arrondir
      MediaPlayerMusique.Play;
      ProgressBarMusique.Position := MediaPlayerMusique.Position;

   {Affichage du temps restant}
   SecondeTotal := round(MediaPlayerMusique.Position / 1000); // identique  la procedure ci-dessus
   Minute := (SecondeTotal div 60);
   Seconde := (SecondeTotal mod 60);

   if Minute < 10 then
   begin
     if Seconde < 10 then
        LabelTempsMusique.Caption :=  '0'+inttostr(Minute)+' : '+'0'+inttostr(Seconde)
     else
        LabelTempsMusique.Caption :=  '0'+inttostr(Minute)+' : '+inttostr(Seconde);
   end
   else
   begin
     if Seconde < 10 then
        LabelTempsMusique.Caption :=  '0'+inttostr(Minute)+' : '+'0'+inttostr(Seconde)
     else
        LabelTempsMusique.Caption :=  '0'+inttostr(Minute)+' : '+inttostr(Seconde);
   end;

      TimerMusique.Enabled := TRUE;
   end;
end;


{Gestion du temps du mp3 avec un timer : en cours et lorsqu'il arrive en fin de lecture}
procedure TFormMusique.TimerMusiqueTimer(Sender: TObject);
var
  SecondeTotal : Integer;
  Minute,Seconde : byte;
  
begin
   if MediaPlayerMusique.Position = MediaPlayerMusique.TrackLength[1] then // fin du Mp3
   begin
      LectureDeLaMusique(TableauAdresseMusique[QuelEstIndiceActuel]);
   end
   else  // Mp3 en cours de lecture
   begin
     Application.ProcessMessages;
     ProgressBarMusique.Position := MediaPlayerMusique.Position; {position de la barre de progression}
     {Affichage du temps restant}
     SecondeTotal := round(MediaPlayerMusique.Position / 1000);  // transformation de milliseconde en seconde
     Minute := (SecondeTotal div 60);    // en divise les seconde par 60 = minutes
     Seconde := (SecondeTotal mod 60);  // le reste de la division precedente = secondes restantes

   if Minute < 10 then // Gestion de l'criture du temps avec 2 chiffre ou 1 seul chiffre
   begin
     if Seconde < 10 then
        LabelTempsMusique.Caption :=  '0'+inttostr(Minute)+' : '+'0'+inttostr(Seconde)
     else
        LabelTempsMusique.Caption :=  '0'+inttostr(Minute)+' : '+inttostr(Seconde);
   end
   else
   begin
     if Seconde < 10 then
        LabelTempsMusique.Caption :=  '0'+inttostr(Minute)+' : '+'0'+inttostr(Seconde)
     else
        LabelTempsMusique.Caption :=  '0'+inttostr(Minute)+' : '+inttostr(Seconde);
   end;
   end;
end;

{Lecture de la musique}
procedure TFormMusique.ImageLectureClick(Sender: TObject);
begin
  if EtreEnPause = TRUE then
        ImagePauseClick(Self)
  else
    LectureDeLaMusique(TableauAdresseMusique[IndiceMusique]); // Premiere musique
end;


{Lecture de la musique}
procedure TFormMusique.LectureDeLaMusique(CheminMusique : string);
var
  NomMusique: string;
begin
  EtreEnPause := FALSE;
  fillchar(NomDuMp3Defilement,sizeof(NomDuMp3Defilement),0);   // vider tout le tableau
  {Initialisation pour la lecture du mp3}

  MediaPlayerMusique.Close;
  MediaPlayerMusique.FileName := CheminMusique;
  MediaPlayerMusique.Open;
  MediaPlayerMusique.TimeFormat:= tfMilliseconds;
  ProgressBarMusique.Max := MediaPlayerMusique.TrackLength[1];
  ProgressBarMusique.Position := 0;
  LabelTempsMusique.Caption := '00 : 00';
  MediaPlayerMusique.Play;

  {Renvoyer le nom du fichier musical}
  NomMusique := droiteDroite('\',CheminMusique);
  NomMusique := copy(NomMusique,1,length(NomMusique)-4);
  RemplirTableauNomMP3Defilement(NomMusique,MediaPlayerMusique.TrackLength[1]);

  TimerMusique.Enabled := TRUE;  {Activation du timer}
end;




{Remplir le tableau de defilement :
 prendre chaque caractere du titre du mp3 + ajouter le temps}
procedure TFormMusique.RemplirTableauNomMP3Defilement(Nom : string; temps : Longword);
var
  SecondeTotal,i,j,k,m,x,y : Integer;
  Minute,Seconde : byte;
  LaMinute, LaSeconde : string;

begin
   SecondeTotal := round(temps / 1000);
   Minute := (SecondeTotal div 60);
   Seconde := (SecondeTotal mod 60);

   if Minute < 10 then
       LaMinute := '0'+inttostr(Minute)
   else
       LaMinute := inttostr(Minute);

   if Seconde < 10 then
       LaSeconde := '0'+inttostr(Seconde)
   else
       LaSeconde := inttostr(Seconde);

   for i:=0 to length(Nom)-1 do    // toutes les lettres du MP3
   begin
     setlength(NomDuMp3Defilement,i+1);
     NomDuMp3Defilement[i] := copy(Nom,i+1,1);
   end;

   for j:=i to i+1 do   // ajoute de 2 espace
   begin
      setlength(NomDuMp3Defilement,j+1);
      NomDuMp3Defilement[j] := ' ';
   end;

   setlength(NomDuMp3Defilement,j+1);  // ajout d'une paranthese
   NomDuMp3Defilement[j] := '(';

   for k := 1 to length(LaMinute) do     // Ajout des minutes
   begin
      setlength(NomDuMp3Defilement,j+k+1);
      NomDuMp3Defilement[j+k] := copy(LaMinute,k,1);
   end;

   m := j+k;
   setlength(NomDuMp3Defilement,m+1);  // ajouter les ":"
   NomDuMp3Defilement[m] := ':';

   for x := 1 to length(LaSeconde) do  // Ajouter les secondes
   begin
      setlength(NomDuMp3Defilement,m+x+1);
      NomDuMp3Defilement[m+x] := copy(LaSeconde,x,1);
   end;

   setlength(NomDuMp3Defilement,m+x+1);  // Fermer la parenthese
   NomDuMp3Defilement[m+x] := ')';

   for y:= m+x+1  to m+x+2 do  // encore 2 espaces
   begin
      setlength(NomDuMp3Defilement,y+1);
      NomDuMp3Defilement[y] := ' ';
   end;

   for y:= m+x+3  to m+x+4 do   // 2 caracteres particuliers pour sparer
   begin
      setlength(NomDuMp3Defilement,y+3);
      NomDuMp3Defilement[y+2] := '*';
   end;

   for y:= m+x+5  to m+x+6 do  // encore 2 derniers espaces
   begin
      setlength(NomDuMp3Defilement,y+5);
      NomDuMp3Defilement[y+4] := ' ';
   end;
   {Toutes les lettres sont places dans le tableau}
   UnDePlus :=0;
end;



procedure TFormMusique.TimerDefilementMusiqueTimer(Sender: TObject);
var
  i,j,x : byte;
  Affichage : string;

begin
  if (TimerMusique.Enabled = TRUE)  and (length(NomDuMp3Defilement) <> 0) then
  begin
    Affichage := '';
    x:=0;
    {32 tant une valeur personnel qui reprsente le nombre de caracteres maximum dans mon Label
    (en majuscule)}
    if length(NomDuMp3Defilement) < 32 then  // longueur inferieur  32
    begin
      for i:=UnDePlus to length(NomDuMp3Defilement)-1 do
        Affichage := Affichage + NomDuMp3Defilement[i];

      if UnDePlus > 0 then
      begin
        for j:= 0 to UnDePlus-1 do
          Affichage := Affichage + NomDuMp3Defilement[j];

      end;
      if UnDePlus = length(NomDuMp3Defilement) then
         UnDePlus := -1;
    end
    else  // longueur superieur  la taille du label
    begin
      for i:=UnDePlus to length(NomDuMp3Defilement)-1 do
      begin
        Affichage := Affichage + NomDuMp3Defilement[i];
        inc(x);
        if x = 31 then
          break;
      end;

      if (UnDePlus > 0) and (x <> 31) then
      begin
        for j:= 0 to UnDePlus-1 do
        begin
          Affichage := Affichage + NomDuMp3Defilement[j];
          inc(x);
          if x = 31 then
            break;
        end;
      end;
      if UnDePlus = length(NomDuMp3Defilement) then
         UnDePlus := -1;
    end;
    application.ProcessMessages;
    LabelDefilement.Caption := Affichage;
    inc(UnDePlus);
  end;
end;

procedure TFormMusique.ImageSuivantClick(Sender: TObject);
begin
  LectureDeLaMusique(TableauAdresseMusique[QuelEstIndiceActuel]);
end;

procedure TFormMusique.ImageArretClick(Sender: TObject);
begin
  if (TimerMusique.Enabled = TRUE) then   // remettre tout  zero
  begin
    MediaPlayerMusique.Close;
    TimerMusique.Enabled := FALSE;
    LabelTempsMusique.Caption := '00 : 00';
    ProgressBarMusique.Position := 0;
    LabelDefilement.Caption := '';
  end;
end;

procedure TFormMusique.ImagePrecedentClick(Sender: TObject);
begin
   if IndiceMusique <> 0 then
   begin
     dec(IndiceMusique);
     LectureDeLaMusique(TableauAdresseMusique[IndiceMusique]);
   end
   else
     LectureDeLaMusique(TableauAdresseMusique[0]);
end;

procedure TFormMusique.ImagePauseClick(Sender: TObject);
begin
  if (TimerMusique.Enabled = TRUE) then
     MediaPlayerMusique.Pause;
  if EtreEnPause = TRUE then
      EtreEnPause := FALSE
  else
     EtreEnPause := TRUE;
end;

end.
